using System.Numerics;

namespace KeepersCompound.TMV;

public static class Utils
{
    const float InverseScale = 4.0f;
    public static Godot.Vector3 ToGodotVec3(this Vector3 vec, bool scale = true)
    {
        return new Godot.Vector3(vec.Y, vec.Z, vec.X) / (scale ? InverseScale : 1.0f);
    }
}